#include <fstream>
#include <math.h>

//Harvest executable for testing.  There should be one argument.  If the 
//argument is "yes", this expects the presence of the file "parameters5.txt",
//which it will test for correctness.  It will then write a file whose name
//is based on the run number it finds in "parameters5.txt".  If the argument
//is "no", it will not look for "parameters5.txt", and instead will always
//write a file called "batch.txt".
int main (int argc, char * argv[]) {
  using namespace std;
  
  if (2 != argc) {
    //Purposefully crash
    int iTemp = (7 - 6) - 1;
    int iTemp2 = 2 / iTemp;
  }
  
  char cTemp[100];
  
  if (argc > 1 && strcmp(argv[1], "yes") == 0) {
    ifstream infile( "C:\\SORTIE\\Code\\Core_Model_Tester\\parameters5.txt" );
    //Make sure that there's only one line
    infile.getline(cTemp, 100);
    infile.getline(cTemp, 100);
    if (!infile.eof()) {
      //Purposefully crash
      int iTemp = (7 - 6) - 1;
      int iTemp2 = 2 / iTemp;
    }
    infile.close();
  
    ifstream infile2( "C:\\SORTIE\\Code\\Core_Model_Tester\\parameters5.txt" );
    float fFakeParam;
    int iRun, iFakeParam;

    infile2 >> iRun >> iFakeParam >> fFakeParam;
    infile2.close();

    if (1 == iRun) {

      if (30 != iFakeParam) {
        //Purposefully crash
        int iTemp = (7 - 6) - 1;
        int iTemp2 = 2 / iTemp;
      }

      if (fabs(32.676 - fFakeParam) > 0.01) {
        //Purposefully crash
        int iTemp = (7 - 6) - 1;
        int iTemp2 = 2 / iTemp;
      }

      ofstream outfile ("c:\\sortie\\code\\core_model_tester\\batch1.txt");
      outfile << "Saw the first run.";
      outfile.close();

    } else if (2 == iRun) {

      if (86 != iFakeParam) {
        //Purposefully crash
        int iTemp = (7 - 6) - 1;
        int iTemp2 = 2 / iTemp;
      }

      if (fabs(65.333 - fFakeParam) > 0.01) {
        //Purposefully crash
        int iTemp = (7 - 6) - 1;
        int iTemp2 = 2 / iTemp;
      }

      ofstream outfile ("c:\\sortie\\code\\core_model_tester\\batch2.txt");
      outfile << "Saw the first run.";
      outfile.close();

    } else if (3 == iRun) {

      if (0 != iFakeParam) {
        //Purposefully crash
        int iTemp = (7 - 6) - 1;
        int iTemp2 = 2 / iTemp;
      }

      if (fabs(-0.34 - fFakeParam) > 0.01) {
        //Purposefully crash
        int iTemp = (7 - 6) - 1;
        int iTemp2 = 2 / iTemp;
      }

      ofstream outfile ("c:\\sortie\\code\\core_model_tester\\batch3.txt");
      outfile << "Saw the first run.";
      outfile.close();

    } else {
      //Purposefully crash
      int iTemp = (7 - 6) - 1;
      int iTemp2 = 2 / iTemp;
    }
  } else if (argc > 1 && strcmp(argv[1], "no") == 0) {
    ofstream outfile ("c:\\sortie\\code\\core_model_tester\\batch.txt");
    outfile << "Saw the batch run.";
    outfile.close();
  } else {
    //Purposefully crash
    int iTemp = (7 - 6) - 1;
    int iTemp2 = 2 / iTemp;
  }
  
  //Copy the harvest file
  ifstream infile3( "C:\\SORTIE\\Code\\Core_Model_Tester\\test5harvest.txt" );
  ofstream outfile2 ("c:\\sortie\\code\\core_model_tester\\cutfile5.txt");
   
  while (!infile3.eof()) {
    infile3.getline(cTemp,100);
    outfile2 << cTemp << endl;
  }

  infile3.close();
  outfile2.close();

  return 0;
}
